/*!
 * Fuse.js v3.5.0 - Lightweight fuzzy-search (http://fusejs.io)
 * 
 * Copyright (c) 2012-2017 Kirollos Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define("Fuse",[],t):"object"==typeof exports?exports.Fuse=t():e.Fuse=t()}(this,function(){return function(e){var t={};function n(r){if(t[r])return t[r].exports;var o=t[r]={i:r,l:!1,exports:{}};return e[r].call(o.exports,o,o.exports,n),o.l=!0,o.exports}return n.m=e,n.c=t,n.d=function(e,t,r){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:r})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(n.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var o in e)n.d(r,o,function(t){return e[t]}.bind(null,o));return r},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=0)}([function(e,t,n){function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function o(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}var i=n(1),a=n(7),s=a.get,c=(a.deepValue,a.isArray),l=function(){function e(t,n){var r=n.location,o=void 0===r?0:r,i=n.distance,a=void 0===i?100:i,c=n.threshold,l=void 0===c?.6:c,h=n.maxPatternLength,u=void 0===h?32:h,f=n.caseSensitive,v=void 0!==f&&f,d=n.tokenSeparator,p=void 0===d?/ +/g:d,g=n.findAllMatches,y=void 0!==g&&g,m=n.minMatchCharLength,k=void 0===m?1:m,S=n.id,b=void 0===S?null:S,x=n.keys,M=void 0===x?[]:x,_=n.shouldSort,L=void 0===_||_,A=n.getFn,w=void 0===A?s:A,C=n.sortFn,O=void 0===C?function(e,t){return e.score-t.score}:C,j=n.tokenize,I=void 0!==j&&j,P=n.matchAllTokens,F=void 0!==P&&P,T=n.includeMatches,z=void 0!==T&&T,E=n.includeScore,N=void 0!==E&&E,K=n.verbose,$=void 0!==K&&K;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.options={location:o,distance:a,threshold:l,maxPatternLength:u,isCaseSensitive:v,tokenSeparator:p,findAllMatches:y,minMatchCharLength:k,id:b,keys:M,includeMatches:z,includeScore:N,shouldSort:L,getFn:w,sortFn:O,verbose:$,tokenize:I,matchAllTokens:F},this.setCollection(t)}var t,n,a;return t=e,(n=[{key:"setCollection",value:function(e){return this.list=e,e}},{key:"search",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{limit:!1};this._log('---------\nSearch pattern: "'.concat(e,'"'));var n=this._prepareSearchers(e),r=n.tokenSearchers,o=n.fullSearcher,i=this._search(r,o),a=i.weights,s=i.results;return this._computeScore(a,s),this.options.shouldSort&&this._sort(s),t.limit&&"number"==typeof t.limit&&(s=s.slice(0,t.limit)),this._format(s)}},{key:"_prepareSearchers",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",t=[];if(this.options.tokenize)for(var n=e.split(this.options.tokenSeparator),r=0,o=n.length;r<o;r+=1)t.push(new i(n[r],this.options));return{tokenSearchers:t,fullSearcher:new i(e,this.options)}}},{key:"_search",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],t=arguments.length>1?arguments[1]:void 0,n=this.list,r={},o=[];if("string"==typeof n[0]){for(var i=0,a=n.length;i<a;i+=1)this._analyze({key:"",value:n[i],record:i,index:i},{resultMap:r,results:o,tokenSearchers:e,fullSearcher:t});return{weights:null,results:o}}for(var s={},c=0,l=n.length;c<l;c+=1)for(var h=n[c],u=0,f=this.options.keys.length;u<f;u+=1){var v=this.options.keys[u];if("string"!=typeof v){if(s[v.name]=v.weight,v.weight<=0||v.weight>1)throw new Error("Key weight has to be > 0 and <= 1");v=v.name}else s[v]=1;this._analyze({key:v,value:this.options.getFn(h,v),record:h,index:c},{resultMap:r,results:o,tokenSearchers:e,fullSearcher:t})}return{weights:s,results:o}}},{key:"_analyze",value:function(e,t){var n=this,r=e.key,o=e.arrayIndex,i=void 0===o?-1:o,a=e.value,s=e.record,l=e.index,h=t.tokenSearchers,u=void 0===h?[]:h,f=t.fullSearcher,v=t.resultMap,d=void 0===v?{}:v,p=t.results,g=void 0===p?[]:p;!function e(t,o,i,a){if(null!=o)if("string"==typeof o){var s=!1,l=-1,h=0;n._log("\nKey: ".concat(""===r?"--":r));var v=f.search(o);if(n._log('Full text: "'.concat(o,'", score: ').concat(v.score)),n.options.tokenize){for(var p=o.split(n.options.tokenSeparator),y=p.length,m=[],k=0,S=u.length;k<S;k+=1){var b=u[k];n._log('\nPattern: "'.concat(b.pattern,'"'));for(var x=!1,M=0;M<y;M+=1){var _=p[M],L=b.search(_),A={};L.isMatch?(A[_]=L.score,s=!0,x=!0,m.push(L.score)):(A[_]=1,n.options.matchAllTokens||m.push(1)),n._log('Token: "'.concat(_,'", score: ').concat(A[_]))}x&&(h+=1)}l=m[0];for(var w=m.length,C=1;C<w;C+=1)l+=m[C];l/=w,n._log("Token score average:",l)}var O=v.score;l>-1&&(O=(O+l)/2),n._log("Score average:",O);var j=!n.options.tokenize||!n.options.matchAllTokens||h>=u.length;if(n._log("\nCheck Matches: ".concat(j)),(s||v.isMatch)&&j){var I={key:r,arrayIndex:t,value:o,score:O};n.options.includeMatches&&(I.matchedIndices=v.matchedIndices);var P=d[a];P?P.output.push(I):(d[a]={item:i,output:[I]},g.push(d[a]))}}else if(c(o))for(var F=0,T=o.length;F<T;F+=1)e(F,o[F],i,a)}(i,a,s,l)}},{key:"_computeScore",value:function(e,t){this._log("\n\nComputing score:\n");for(var n=0,r=t.length;n<r;n+=1){for(var o=t[n],i=o.output,a=i.length,s=1,c=0;c<a;c+=1){var l=i[c],h=l.key,u=e?e[h]:1,f=0===l.score&&e&&e[h]>0?Number.EPSILON:l.score;s*=Math.pow(f,u)}o.score=s,this._log(o)}}},{key:"_sort",value:function(e){this._log("\n\nSorting...."),e.sort(this.options.sortFn)}},{key:"_format",value:function(e){var t=[];if(this.options.verbose){var n=[];this._log("\n\nOutput:\n\n",JSON.stringify(e,function(e,t){if("object"===r(t)&&null!==t){if(-1!==n.indexOf(t))return;n.push(t)}return t})),n=null}var o=[];this.options.includeMatches&&o.push(function(e,t){var n=e.output;t.matches=[];for(var r=0,o=n.length;r<o;r+=1){var i=n[r];if(0!==i.matchedIndices.length){var a={indices:i.matchedIndices,value:i.value};i.key&&(a.key=i.key),i.hasOwnProperty("arrayIndex")&&i.arrayIndex>-1&&(a.arrayIndex=i.arrayIndex),t.matches.push(a)}}}),this.options.includeScore&&o.push(function(e,t){t.score=e.score});for(var i=0,a=e.length;i<a;i+=1){var s=e[i];if(this.options.id&&(s.item=this.options.getFn(s.item,this.options.id)[0]),o.length){for(var c={item:s.item},l=0,h=o.length;l<h;l+=1)o[l](s,c);t.push(c)}else t.push(s.item)}return t}},{key:"_log",value:function(){var e;this.options.verbose&&(e=console).log.apply(e,arguments)}}])&&o(t.prototype,n),a&&o(t,a),e}();e.exports=l},function(e,t,n){function r(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}var o=n(2),i=n(3),a=n(6),s=function(){function e(t,n){var r=n.location,o=void 0===r?0:r,i=n.distance,s=void 0===i?100:i,c=n.threshold,l=void 0===c?.6:c,h=n.maxPatternLength,u=void 0===h?32:h,f=n.isCaseSensitive,v=void 0!==f&&f,d=n.tokenSeparator,p=void 0===d?/ +/g:d,g=n.findAllMatches,y=void 0!==g&&g,m=n.minMatchCharLength,k=void 0===m?1:m,S=n.includeMatches,b=void 0!==S&&S;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.options={location:o,distance:s,threshold:l,maxPatternLength:u,isCaseSensitive:v,tokenSeparator:p,findAllMatches:y,includeMatches:b,minMatchCharLength:k},this.pattern=v?t:t.toLowerCase(),this.pattern.length<=u&&(this.patternAlphabet=a(this.pattern))}var t,n,s;return t=e,(n=[{key:"search",value:function(e){var t=this.options,n=t.isCaseSensitive,r=t.includeMatches;if(n||(e=e.toLowerCase()),this.pattern===e){var a={isMatch:!0,score:0};return r&&(a.matchedIndices=[[0,e.length-1]]),a}var s=this.options,c=s.maxPatternLength,l=s.tokenSeparator;if(this.pattern.length>c)return o(e,this.pattern,l);var h=this.options,u=h.location,f=h.distance,v=h.threshold,d=h.findAllMatches,p=h.minMatchCharLength;return i(e,this.pattern,this.patternAlphabet,{location:u,distance:f,threshold:v,findAllMatches:d,minMatchCharLength:p,includeMatches:r})}}])&&r(t.prototype,n),s&&r(t,s),e}();e.exports=s},function(e,t){var n=/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g;e.exports=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:/ +/g,o=new RegExp(t.replace(n,"\\$&").replace(r,"|")),i=e.match(o),a=!!i,s=[];if(a)for(var c=0,l=i.length;c<l;c+=1){var h=i[c];s.push([e.indexOf(h),h.length-1])}return{score:a?.5:1,isMatch:a,matchedIndices:s}}},function(e,t,n){var r=n(4),o=n(5);e.exports=function(e,t,n,i){for(var a=i.location,s=void 0===a?0:a,c=i.distance,l=void 0===c?100:c,h=i.threshold,u=void 0===h?.6:h,f=i.findAllMatches,v=void 0!==f&&f,d=i.minMatchCharLength,p=void 0===d?1:d,g=i.includeMatches,y=void 0!==g&&g,m=s,k=e.length,S=u,b=e.indexOf(t,m),x=t.length,M=[],_=0;_<k;_+=1)M[_]=0;if(-1!==b){var L=r(t,{errors:0,currentLocation:b,expectedLocation:m,distance:l});if(S=Math.min(L,S),-1!==(b=e.lastIndexOf(t,m+x))){var A=r(t,{errors:0,currentLocation:b,expectedLocation:m,distance:l});S=Math.min(A,S)}}b=-1;for(var w=[],C=1,O=x+k,j=1<<(x<=31?x-1:30),I=0;I<x;I+=1){for(var P=0,F=O;P<F;){r(t,{errors:I,currentLocation:m+F,expectedLocation:m,distance:l})<=S?P=F:O=F,F=Math.floor((O-P)/2+P)}O=F;var T=Math.max(1,m-F+1),z=v?k:Math.min(m+F,k)+x,E=Array(z+2);E[z+1]=(1<<I)-1;for(var N=z;N>=T;N-=1){var K=N-1,$=n[e.charAt(K)];if($&&(M[K]=1),E[N]=(E[N+1]<<1|1)&$,0!==I&&(E[N]|=(w[N+1]|w[N])<<1|1|w[N+1]),E[N]&j&&(C=r(t,{errors:I,currentLocation:K,expectedLocation:m,distance:l}))<=S){if(S=C,(b=K)<=m)break;T=Math.max(1,2*m-b)}}if(r(t,{errors:I+1,currentLocation:m,expectedLocation:m,distance:l})>S)break;w=E}var J={isMatch:b>=0,score:0===C?.001:C};return y&&(J.matchedIndices=o(M,p)),J}},function(e,t){e.exports=function(e,t){var n=t.errors,r=void 0===n?0:n,o=t.currentLocation,i=void 0===o?0:o,a=t.expectedLocation,s=void 0===a?0:a,c=t.distance,l=void 0===c?100:c,h=r/e.length,u=Math.abs(s-i);return l?h+u/l:u?1:h}},function(e,t){e.exports=function(){for(var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,n=[],r=-1,o=-1,i=0,a=e.length;i<a;i+=1){var s=e[i];s&&-1===r?r=i:s||-1===r||((o=i-1)-r+1>=t&&n.push([r,o]),r=-1)}return e[i-1]&&i-r>=t&&n.push([r,i-1]),n}},function(e,t){e.exports=function(e){for(var t={},n=e.length,r=0;r<n;r+=1)t[e.charAt(r)]=0;for(var o=0;o<n;o+=1)t[e.charAt(o)]|=1<<n-o-1;return t}},function(e,t){var n=function(e){return Array.isArray?Array.isArray(e):"[object Array]"===Object.prototype.toString.call(e)},r=function(e){return null==e?"":function(e){if("string"==typeof e)return e;var t=e+"";return"0"==t&&1/e==-1/0?"-0":t}(e)},o=function(e){return"string"==typeof e},i=function(e){return"number"==typeof e};e.exports={get:function(e,t){var a=[];return function e(t,s){if(s){var c=s.indexOf("."),l=s,h=null;-1!==c&&(l=s.slice(0,c),h=s.slice(c+1));var u=t[l];if(null!=u)if(h||!o(u)&&!i(u))if(n(u))for(var f=0,v=u.length;f<v;f+=1)e(u[f],h);else h&&e(u,h);else a.push(r(u))}else a.push(t)}(e,t),a},isArray:n,isString:o,isNum:i,toString:r}}])});